<script src="@#file#(simpletransf.js)" type="text/javascript"></script>
<p>Kada govorimo o skaliranju, možemo razmatrati specifičniji slučaj uniformnog skaliranja te općenitiji slučaj neuniformnog skaliranja. Uniformno skaliranje mijenja normu vektora (duljinu) no rezultantni vektor je i dalje kolinearan početnom. Ovu transformaciju možemo zapisati na sljedeći način:
\[
S(\vec x) = s \cdot \vec x \quad \mbox{ gdje je }s\mbox{ skalar.}
\]
Ako je \(s \in (0,1)\), rezultantni vektor će biti kraći (ali i dalje gledati u istom smjeru); ako je \(s &gt; 1\), rezultantni vektor će biti dulji (ali i dalje gledati u istom smjeru). Ako je \(s &lt; 0\), apsolutna vrijednost od \(s\) će modificirati duljinu vektora na prethodno opisani način ali dobiveni vektor bit će suprotnog smjera. U oba slučaja, međutim, početni vektor i skalirani vektor bit će kolinearni.
</p>

<p>Primjer u nastavku ilustrira djelovanje uniformnog skaliranja. Klikom miša u platno pa povlačenjem možete mijenjati početni vektor. Demonstracija prikazuje rezultantni vektor dobiven uniformnim skaliranjem zadanim faktorom. Faktor skaliranja možete podešavati kliznikom ispod platna. Originalni vektor prikazan je crnom bojom, skalirani crvenom.</p>
 
<div width="500" height="500" style="position:relative; width:500px; margin: auto;">
<canvas id="myCanvas1" width="500" height="500" style="border: 1px solid white;"></canvas>
</div>
<div style="position:relative; width:500px; margin: auto;">
Faktor skaliranja: <span id="example1_s">0.5</span><br><input 
  onchange="example1.transform[0][0]=this.valueAsNumber; example1.transform[1][1]=this.valueAsNumber; example1.paint(); document.getElementById('example1_s').innerHTML=this.value;"
  oninput="example1.transform[0][0]=this.valueAsNumber; example1.transform[1][1]=this.valueAsNumber; example1.paint(); document.getElementById('example1_s').innerHTML=this.value;"
 type="range" min="-4" max="4" value="0.5" step="0.1">
</div>
<script type="text/javascript">
  var example1 = new SimpleTransfCanvas("myCanvas1");
  example1.transform[0][0]=0.5;
  example1.transform[1][1]=0.5;
  example1.paint();
</script>

<p>Skaliranje je linearna transformacija (i uniformno i neuniformno); vrijedi:
\[
S(\vec x + \vec y) = S(\vec x) + S(\vec y) \\
S(\lambda \cdot \vec x) = \lambda \cdot S(\vec x)
\]
u što se možete jednostavno uvjeriti. S obzirom na prethodno dani izraz koji opisuje uniformno skaliranje:
\[
S(\vec x) = s \cdot \vec x
\]
matrični zapis ove transformacije je sljedeći:
\[
[\begin{array}{cc}\hat x &amp; \hat y\end{array}] = 
[\begin{array}{cc}x &amp; y\end{array}] \cdot
\left[ \begin{array}{cc}s &amp; 0\\ 0 &amp; s\end{array} \right].
\]   
odnosno ako radimo s točkama u homogenom prostoru, transformaciju možemo zapisati kao afinu transformaciju koristeći samo jednu matricu:
\[
[\begin{array}{ccc}\hat x &amp; \hat y &amp; 1\end{array}] = 
[\begin{array}{ccc}x &amp; y &amp; 1\end{array}] \cdot
\left[ \begin{array}{ccc}s &amp; 0 &amp; 0\\ 0 &amp; s &amp; 0\\ 0 &amp; 0 &amp; 1\end{array} \right].
\]
</p>

<p>Neuniformno skaliranje omogućava da se x-os i y-os skaliraju nezavisnim faktorima. Matrični zapis ove transformacije je sljedeći:
\[
[\begin{array}{cc}\hat x &amp; \hat y\end{array}] = 
[\begin{array}{cc}x &amp; y\end{array}] \cdot
\left[ \begin{array}{cc}s_x &amp; 0\\ 0 &amp; s_y\end{array} \right].
\]   
odnosno ako radimo s točkama u homogenom prostoru, transformaciju možemo zapisati kao afinu transformaciju koristeći samo jednu matricu:
\[
[\begin{array}{ccc}\hat x &amp; \hat y &amp; 1\end{array}] = 
[\begin{array}{ccc}x &amp; y &amp; 1\end{array}] \cdot
\left[ \begin{array}{ccc}s_x &amp; 0 &amp; 0\\ 0 &amp; s_y &amp; 0\\ 0 &amp; 0 &amp; 1\end{array} \right].
\]
</p>

<div width="500" height="500" style="position:relative; width:500px; margin: auto;">
<canvas id="myCanvas2" width="500" height="500" style="border: 1px solid white;"></canvas>
</div>
<div style="position:relative; width:500px; margin: auto;">
Faktor skaliranja po osi x: <span id="example2_sx">1</span><br><input 
  onchange="example2.transform[0][0]=this.valueAsNumber; example2.paint(); document.getElementById('example2_sx').innerHTML=this.value;"
  oninput="example2.transform[0][0]=this.valueAsNumber; example2.paint(); document.getElementById('example2_sx').innerHTML=this.value;"
 type="range" min="-4" max="4" value="1" step="0.1"><br>
Faktor skaliranja po osi y: <span id="example2_sy">0.5</span><br><input 
  onchange="example2.transform[1][1]=this.valueAsNumber; example2.paint(); document.getElementById('example2_sy').innerHTML=this.value;"
  oninput="example2.transform[1][1]=this.valueAsNumber; example2.paint(); document.getElementById('example2_sy').innerHTML=this.value;"
 type="range" min="-4" max="4" value="0.5" step="0.1"><br>
</div>
<script type="text/javascript">
  var example2 = new SimpleTransfCanvas("myCanvas2");
  example2.transform[0][0]=1;
  example2.transform[1][1]=0.5;
  example2.paint();
</script>

<p>Interaktivna demonstracija u nastavku ilustrira djelovanje skaliranja nad dvodimenzijskim objektom. Primijetite da skaliranje modificira površinu objekta: kod rotacije to nije bio slučaj. Neuniformno skaliranje također mijenja relativni odnos između linija: pod njegovim djelovanjem mijenjat će se kutevi između linija (pri čemu su iznimke linije okomite na smjerove skaliranja: kut između njih i nakon skaliranja ostaje 90°). Da je to istina, lagano se uvjeriti ako zamislite jedan trokut čiji su vrhovi (0,0), (1,1) i (0,2) koji potom skalirate samo po osi x faktorom 10. Koji su kutevi između stranica trokuta prije a koji poslije skaliranja? Razumijete li zašto uniformno skaliranje neće utjecati na kuteve?</p>
  
<!-- Demonstracija skaliranja -->
@#page-include#(shaders.html)
@#page-include#(scaling-sim-hr.html)
<!-- Demonstracija skaliranja -->
